//----- df.c ----- 01/12/10 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2010-01-12 - Mark Davis
//               - added -k option
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  show usage data for each file system
//-----------------------------------------------------------------------------
void _task _df(int argc, char **argv)
{
  ulong  used, unused;
  uint  percentUsed;
  bool  useK = false;

/*
Filesystem           1K-blocks      Used Available Use% Mounted on
/dev/hda1               806560    699552     66036  92% /
tmpfs                   518260         4    518256   1% /dev/shm
/dev/hda8             57600116   2371096  52303052   5% /scratch
/dev/hda6              2771088     32896   2597428   2% /tmp
/dev/hda7              8817736   3232164   5137644  39% /usr
/dev/hda5              4533672    223508   4079864   6% /var
*/

  if (showHelp(1, argc, argv))  {
    printf("\nusage:  %s [-k]\r\n", argv[0]);  Exit(-1); }

  if (argc > 1)  useK = StriEq(argv[1], "-k");

  unused = ffile_free();  used = flashSize - unused;
  percentUsed = (uint)(used * 100 / flashSize);

  printf(
"Filesystem                   Size      Used Available Use%% Mounted on\r\n");
//                       ######### ######### ######### ###% /../..
  if (useK)
    printf("/dev/flash              %8luk %8luk %8luk %3d%% /\r\n",
                  flashSize/1024L, used/1024L, unused/1024L, percentUsed);
  else
    printf("/dev/flash              %9lu %9lu %9lu %3d%% /\r\n",
           flashSize, used, unused, percentUsed);

  Exit(0);
}

//-----------------------------------------------------------------------------
