//----- free.c ----- 09/22/10 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2010-09-22 - Mark Davis
//               - Added free root memory to the output
//
//  2010-01-12 - Mark Davis
//               - added -k option
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  show memory usage data
//-----------------------------------------------------------------------------
void _task _free(int argc, char **argv)
{
  bool  useK = false;
  uint  freeRoot, percent;
  ulong  used, unused, freeXmem;

/*
             total       used       free     shared    buffers     cached
Mem:       1036524     691288     345236          0     196516     253800
-/+ buffers/cache:     240972     795552
Swap:      2431792          0    2431792
*/

  if (showHelp(1, argc, argv))  {
    printf("\nusage:  %s [-k]\r\n", argv[0]);  Exit(-1); }

  if (argc > 1)  useK = StriEq(argv[1], "-k");

//ramSize = detectedRAM();  //tdebug

/*
                                ---- free ----
             total       used   extended  root       Use%
Mem:          768k       556k       211k  xxxk        72%

-- OR --                        ---- free ----
             total       used   extended  root       Use%
Mem:        786432     569584     216848 xxxxx        72%
*/

  freeRoot = (uint)0xD000 - bssStart - bssSize;
  freeXmem = xavail();

  unused = (ulong)freeRoot + freeXmem;  used = ramSize - unused;
  percent = (uint) ((used * 100) / ramSize);

  printf("                                ---- free ----\r\n"
         "             total       used   extended  root       Use%%\r\n");
//        Mem:      ########   ########   ######## #####       ###%
//        Mem:      #######k   #######k   #######k ####k       ###%


  if (useK)
    printf("Mem:      %7luk   %7luk   %7luk %4uk       %3u%%\r\n\n",
           ramSize/1024L, used/1024L, freeXmem/1024L, freeRoot/1024, percent);
  else
    printf("Mem:      %8lu   %8lu   %8lu %5u       %3d%%\r\n\n",
           ramSize, used, freeXmem, freeRoot, percent);

  Exit(0);
}

//-----------------------------------------------------------------------------
