//----- getty.c ----- 04/02/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  cmd to spawn a login shell using the specified file/device for stdio
//-----------------------------------------------------------------------------
void _task getty(int argc, char **argv)
{
  fd_t  serialfd;
  PID  pid;
  int  status;
  ulong  baudRate;
  char  *argv_[2];
  uint  argc_;


  if (showHelp(3, argc, argv))  {
    printf("\nusage: getty baudrate port\r\n");  Exit(-1); }

  if ((serialfd = open(argv[2], O_RDWR, 0)) < 0)  {
    printf("getty: Unable to open device: %s\r\n", argv[2]);
    perror("getty");  Exit(-2);
  }

  baudRate = atol(argv[1]);  ioctl(serialfd, IOC_SET_BAUD, &baudRate);

  for (;;)  {
    argv_[0] = "tsh";  argv_[1] = NULL;  argc_ = 1;
    pid = createProc(tsh, 10, argc_, argv_, serialfd, serialfd, serialfd);
    if (pid > 0)  {
      printf("shell started on %.32s\r\n", argv[2]);
      waitpid(pid, &status, 0);
    }
    else  {
      printf("Unable to start tty shell\r\n");  sleepMS(30000); }
  }

}

//-----------------------------------------------------------------------------
