//----- inttab.c ----- 06/02/10 -----(12/09/09)-----

//-----------------------------------------------------------------------------
//
//  2010-06-02 - Mark Davis
//               - Replaced redundant code with call to showIntVectors()
//
//  2010-03-31 - Mark Davis
//               - Move InvVectDesc[] to hdwdefs.c
//
//  2009-12-20 - Mark Davis
//               - changes "table" option to "show"
//
//  2009-12-09 - Mark Davis
//               - original version
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <timerb.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  Command to get info on interrupt handlers
//-----------------------------------------------------------------------------
void _task _inttab(int argc, char **argv)
{
  if (showHelp(2, argc, argv))  {
    printf("\nusage: inttab uhi|show\r\n");  Exit(-1); }


  if (StriEq(argv[1], "uhi"))  {
    interruptHandler handler;
    handler = getInterruptHandler(2);  // an "unhandled interrupt"
    handler();  // Simulate an "unhandled interrupt"
    Exit(0);
  }

  if (StriEq(argv[1], "show"))  { showIntVectors();  Exit(0); }

  printf("Unknown option: %.32s\r\n", argv[1]);  Exit(-1);
}

//-----------------------------------------------------------------------------
