//----- ls.c ----- 03/12/10 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2010-03-12 - Mark Davis
//               - Added locking around calls to get file information
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  list files
//-----------------------------------------------------------------------------
void _task _ls(int argc, char **argv)
{
  uint  idx;
  FILE_ENTRY far *fe;
  FILE_ENTRY  fileData;
  char  *permStr;
  char  primaryName[PATH_MAX], backupName[PATH_MAX], infoStr[32];


  if (showHelp(1, argc, argv))  {
    printf("\nusage:  %s\r\n", argv[0]);  Exit(-1); }

//finish - need to use non device-specific API for this info

  ffile_getPrimaryName(primaryName, PATH_MAX);
  ffile_getBackupName(backupName, PATH_MAX);

  for (idx=0; idx<MAX_FILES; ++idx)  {
    KLOCK();
    if ((fe = ffile_info(idx)) == NULL)  { KUNLOCK();  continue; }
    fmemcpy(&fileData, fe, sizeof(FILE_ENTRY));
    KUNLOCK();

    if (strcmp(fileData.name, primaryName) == 0)
      permStr = "-rwxrw-rw-";
    else  if (strcmp(fileData.name, backupName) == 0)
      permStr = "-rwxrwxrw-";
    else
      permStr = "-rw-rw-rw-";

    fileInfoStr(fileData.name, infoStr);

    printf("%s   1 root   root %s %s\r\n", permStr, infoStr, fileData.name);
  }

  Exit(0);
}


//-----------------------------------------------------------------------------
