//----- more.c ----- 03/31/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>

//-----------------------------------------------------------------------------
//  show lines read from stdin or a file a block at a time
//-----------------------------------------------------------------------------
void _task _more(int argc, char **argv)
{
  uchar  ch;
  int i, linesLeft, count;
  int  stat;
  fd_t  datafd, keybdfd;
  ulong  ttlLines;
  char  buf[256];


  if (showHelp(1, argc, argv))  {
    printf("\nusage: more [name]\r\n");  Exit(-1);  }

//--- set the data and keybd fd's ---
  if (argc > 1)  {  // if reading from file: use stdin for keybd cmds
    if ((datafd = open(argv[1], O_RDONLY, 0)) < 0)  {
      perror(argv[1]);  Exit(-1); }
    keybdfd = 0;
  }
  else  {  // reading from stdin: use tty for keybd cmds
    if (isatty(0))  { printf("\nusage: more name\r\n");  Exit(-1); }
    datafd = 0;  //stdin
    if ((keybdfd = open("/dev/tty", O_RDONLY, 0)) < 0)  {
      perror("/dev/tty");  Exit(-1);  }
  }

  linesLeft = 20;  ttlLines = 0;

  while ((stat = read(datafd, buf, sizeof(buf))) > 0)  {
    for (count=i=0; i<stat; ++i)  {
      if (buf[i] != '\n')  { ++count;  continue; }
      if (count)  write(1, buf + (i-count), count);
      write(1, "\r\n", 2);  count = 0;  --linesLeft;  ++ttlLines;
      if (linesLeft < 1)  {
        printf("--more--(%lu)", ttlLines);  fflush(stdout);
        while (linesLeft < 1)  {
          if (read(keybdfd, &ch, 1) != 1)  break;
          ch &= 0x7f;  ch = tolower(ch);
          switch (ch)  {
            case 0x03:  Exit(-1);
            case 'q':   Exit(0);
            case '\r':  linesLeft = 1;   break;
            case 'd':   linesLeft = 12;  break;
            case ' ':   linesLeft = 20;  break;
          }
        }
        printf("\r%s", cllCmd);  fflush(stdout);
      }
    }
    if (count)  write(1, buf + (i-count), count);
  }

  Exit(0);
}


//-----------------------------------------------------------------------------
