//----- rdmem.c ----- 01/22/10 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2010-01-22 - Mark Davis
//               - Added -crc option to compute CRC instead of showing the
//                 values in the given range.
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>

//-----------------------------------------------------------------------------
//  show contents of memory
//-----------------------------------------------------------------------------
void _task _rdmem(int argc, char **argv)
{
  bool  justCRC;
  uchar  i, x;
  ushort  crc;
  ulong  offset, count, remain;
  char far *ptr;
  char  msg[160], buf[16];


  if (showHelp(2, argc, argv))  {
    printf("\nusage: rdmem offset [count] [-crc]\r\n");  Exit(-1); }

  offset = ATOUL(argv[1]);
  if (argc > 2)  count = ATOUL(argv[2]);  else  count = 128;
  if (count < 1)  count = 128;

  justCRC = StriEq(argv[argc-1], "-crc");

  ptr = (char far *)offset;  crc = 0;
  for (remain=count; remain>0; remain-=16)  {
    x = (uchar)((remain >= 16) ? 16 : remain);
    for (i=0; i<x; ++i)  buf[i] = *ptr++;
    if (justCRC)  {
      printf("0x%05lX\r", (ulong)ptr);
      crc = fastCRC16((char *)buf, (uint)x, crc);
    }
    else  {
      fmtHexLine(msg, offset, buf, x);
      strcat(msg, "\r\n");  printf(msg);
    }
    offset += 16;  if (remain < 16)  break;
    CheckETX();
  }

  if (justCRC)  printf("CRC: 0x%04X\r\n", crc);

  Exit(0);
}


//-----------------------------------------------------------------------------
