//----- route.c ----- 01/31/11 -----(01/28/11)-----

//-----------------------------------------------------------------------------
//  Update log (most recent first):
//
//
//  2011-01-31 - Mark Davis
//               - Added ability to add and delete routes
//
//  2011-01-28 - Mark Davis
//               - New command to show the routing table (same as 'netstat -r'
//                 at present)
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>

//-----------------------------------------------------------------------------
void _task _route(int argc, char **argv)
{
//  uint  i;
//  SockInfo  *si;
//  char  buf[80];
  ulong  target, mask, gw;


  if (argc < 2)  { showRoutes();  Exit(0); }


  target = mask = gw = 0;

  if (StrEq(argv[1], "add") AND (argc == 5))  {
    inet_ptoh(AF_INET, argv[2], &target);
    inet_ptoh(AF_INET, argv[3], &mask);
    inet_ptoh(AF_INET, argv[4], &gw);

    if (! gw)  {
      printf("Invalid gateway address: %s\r\n", argv[4]);  Exit(-1);  }

    if (router_add(gw, IF_ETH0, target, mask, 0) > 0)  Exit(0);

    printf("Error trying to add route\r\n");
  }


  if (StrEq(argv[1], "del") AND (argc == 3))  {
    inet_ptoh(AF_INET, argv[4], &gw);

    if (! gw)  {
      printf("Invalid gateway address: %s\r\n", argv[4]);  Exit(-1);  }

    if (router_delete(gw) > 0)  Exit(0);

    printf("Error trying to delete route\r\n");
  }


  printf("\r\n"
         "usage:  route \r\n"
         "        route add target netmask gateway\r\n"
         "        route del gateway\r\n"
        );

  Exit(-1);
}

//-----------------------------------------------------------------------------
